import React from 'react';
import ReactDom from 'react-dom';
import ajax from 'jquery/src/ajax/xhr.js';
import $ from 'jquery/src/ajax';
import { Form,Radio, Icon, Button, Input, Select, Spin, Table, Switch, message, Modal, Upload ,Popconfirm} from 'antd';
import MySettlementDetaile from "./projectOrderDetaile.jsx";
import moment from 'moment';
import './userMangagement.less';
import {lvl,intentProgress,transactionProgress,contractProgress,projectProgress} from '../../../dataDic.js';
import {getIntentProgress,getTransactionProgress,getContractProgress,getProjectProgress} from '../../../tools.js';

const ProjectOrder=Form.create()(React.createClass({
	loadData(pageNo) {
        this.state.data = [];
        this.setState({
            loading: true
        });
        $.ajax({
            method: "post",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + '/api/admin/roles',
            data: {
                pageNo: pageNo || 1,
                pageSize: this.state.pagination.pageSize,
                customerNameSearch:this.state.customerNameSearch,//客户名称
                approvedSearch:this.state.approvedSearch, //是否特批
                orderStatusSearch:this.state.orderStatusSearch, //订单状态
                orderDepartmentSearch:this.state.orderDepartmentSearch, //订单部门
                orderLeaderSearch:this.state.orderLeaderSearch,//订单负责人
                financeLeaderSearch:this.state.financeLeaderSearch,//财务负责人
            },
            success: function (data) {
                let theArr = [];
                if (!data.data) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                } else {
                    for (let i = 0; i < data.data.list.length; i++) {
                        let thisdata = data.data.list[i];
                        theArr.push({
                             key: i,
	                         id: thisdata.id,
	                         roleName: thisdata.roleName,
	                         creater:thisdata.creater,
	                         createTime:thisdata.createTimez,
                        });
                    };
                    this.state.pagination.current = data.data.pageNo;
                    this.state.pagination.total = data.data.totalCount;
                };
                if(!data.data.list.length){
					this.state.pagination.current=0
					this.state.pagination.total=0
				}
                this.setState({
                    dataSource: theArr,
                    pagination: this.state.pagination,
                    selectedRowKeys:[]
                });
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    getInitialState() {
        return {
        	datauser:{},
            selectedRowKeys: [],
            selectedRows: [],
            searchMore: true,
            loading: false,
            distributionVisible:false,
            visible:false,
            showDesc:false,
            pagination: {
                defaultCurrent: 1,
                defaultPageSize: 10,
                showQuickJumper: true,
                pageSize: 10,
                onChange: function (page) {
                    this.loadData(page);
                }.bind(this),
                showTotal: function (total) {
                    return '共' + total + '条数据';
                }
            },
            distributionPagination: {
                defaultCurrent: 1,
                defaultPageSize: 10,
                showQuickJumper: true,
                pageSize: 10,
                onChange: function (page) {
                    this.contactList(page);
                }.bind(this),
                showTotal: function (total) {
                    return '共' + total + '条数据';
                }
            },
            columns: [
                {
                    title: '订单编号',
                    dataIndex: 'roleName',
                    key: 'roleName'
                },{
                    title: '下单时间',
                    dataIndex: 'creater7',
                    key: 'creater7'
                },{
                    title: '客户名称',
                    dataIndex: 'roleName1',
                    key: 'roleName1'
                },
                {
                    title: '订单类型',
                    dataIndex: 'creater1',
                    key: 'creater1'
                }, {
                    title: '订单状态',
                    dataIndex: 'createTime1',
                    key: 'createTime1',
                    render:(text)=>{return getIntentProgress(text) }
                },{
                    title: '结算状态',
                    dataIndex: 'roleName2',
                    key: 'roleName2',
                    render:(text)=>{return getTransactionProgress(text) }
                }, {
                    title: '是否特批',
                    dataIndex: 'creater2',
                    key: 'creater2',
                    render:(text)=>{return getContractProgress(text) }
                },{
                    title: '订单部门',
                    dataIndex: 'creater77',
                    key: 'creater77',
                    render:(text)=>{return getContractProgress(text) }
                },{
                    title: '订单负责人',
                    dataIndex: 'creater9',
                    key: 'creater9',
                },{
                    title: '财务负责人',
                    dataIndex: 'creater91',
                    key: 'creater91',
                },{
                	title: '操作',
                    dataIndex: 'rr',
                    key: 'rr',
                    render:(text,record,index)=>{
                    	return (
                    		<Popconfirm title={'您确认将订单【'+record.roleName+'】进行立项，立项后可进行项目管理。'} onConfirm={(e)=>{this.edit(record)}} okText="确定立项" cancelText="暂不立项">
								<Button style={{marginRight:'5px'}} type="primary" onClick={(e) =>{ e.stopPropagation() }}>立项</Button>                 
							</Popconfirm>
							)
                    }
                }
            ],
            dataSource: [],
        };
    },
    //操作分配
    confirmDelet(index){
    	this.setState({
    		userDetaile:false,
    	});
    	this.contactList(1,index.id)
    },
    //驳回
    reject(record){
    	let api ='api/bohui'
    	this.confirmSelect(api,record)
    },
    //确认
    confirm(record){
    	let api='api/quren'
    	this.confirmSelect(api,record)
    },
    confirmSelect(api,record){
    	this.setState({
            loading: true
        });
        $.ajax({
            method: "POST",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + api,
            data: {
            	id:record.id,
            }
        }).done(function (data) {
            if (!data.error.length) {
                message.success('操作成功');
                this.setState({
                    loading: false,
                });
            } else {
                message.warning(data.error[0].message);
            };
            this.loadData();
        }.bind(this));
    },
    componentWillMount() {
        this.loadData();
    },
    edit(record) {
    	this.state.userDetaile=true;
        this.state.datauser = record;
        this.setState({
            showDesc: true
        });
    },
    closeDesc(e, s) {
    	this.state.userDetaile=false;
        this.state.showDesc = e;
        if (s) {
            this.loadData();
        };
    },
    searchSwitch() {
		this.setState({
			searchMore: !this.state.searchMore
		});
	},
    search() {
        this.loadData();
    },
    //分配时搜索
    searchOrder() {
        this.contactList();
    },
    //分配时重置
    resetOrder() {
        this.contactList();
    },
    reset() {
    	this.state.customerNameSearch='';
		this.state.approvedSearch = undefined;
		this.state.orderStatusSearch = undefined;
		this.state.orderDepartmentSearch = undefined;
		this.state.orderLeaderSearch = '';
		this.state.financeLeaderSearch = '';
        this.loadData();       
    },
    render() {
        const rowSelection = {
            selectedRowKeys: this.state.selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
	                this.setState({
	                    selectedRows: selectedRows.slice(-1),
	                    selectedRowKeys: selectedRowKeys.slice(-1)
	                }); 
            },
            onSelectAll: (selected, selectedRows, changeRows) => {
			   this.setState({
			   		selectedRowKeys:[]
			   })
			},
        };
        const hasSelected = this.state.selectedRowKeys.length > 0;
        return (
            <div className="user-content" >
                <div className="content-title">
                	<span style={{fontSize:'16px'}}>立项订单</span>	
	                <div className="user-search">
	                    <Input placeholder="客户名称" style={{width:'150px'}}
	                        value={this.state.customerNameSearch}
	                        onChange={(e) => { this.setState({ customerNameSearch: e.target.value }); }} />
	                    <Select placeholder="是否特批"
	                        style={{ width: 150 ,marginRight:'10px'}}
	                        value={this.state.approvedSearch}
	                        onChange={(e) => { this.setState({ approvedSearch: e }) }}>
	                        <Select.Option value='0'>未特批</Select.Option>
	                        <Select.Option value='1'>已特批</Select.Option>
                  		</Select>
                        <Select placeholder="订单状态"
	                        style={{ width: 150 ,marginRight:'10px'}}
	                        value={this.state.orderStatusSearch}
	                        onChange={(e) => { this.setState({ orderStatusSearch: e }) }}>
	                        {
	                            lvl.map(function (item) {
	                                    return <Select.Option key={item.value} >{item.key}</Select.Option>
	                            })
	                        }
                  		</Select>
	                    <Button type="primary" onClick={this.search} style={{marginLeft:'10px'}}>搜索</Button>
	                    <Button onClick={this.reset}>重置</Button>
	                    <span style={{marginLeft:'10px',marginRight:'20px'}}>更多搜索<Switch defaultChecked={false} onChange={this.searchSwitch} /></span>    
	                </div>
	                <div className='clearfix' style={{marginTop:'5px'}}>
	                  <div className="search-more" style={this.state.searchMore ? { display: 'none' } : {}}> 
	                        <Select placeholder="订单部门"
	                            style={{ width: 150 ,marginRight:'10px'}}
	                            value={this.state.orderDepartmentSearch}
	                            onChange={(e) => { this.setState({ orderDepartmentSearch: e }) }}>
	                            {
                                    lvl.map(function (item) {
                                            return <Select.Option key={item.value} >{item.key}</Select.Option>
                                    })
                                }
	                        </Select>
	                        <Input placeholder="订单负责人" style={{width:'150px',marginRight:'10px'}}
		                        value={this.state.orderLeaderSearch}
		                        onChange={(e) => { this.setState({ orderLeaderSearch: e.target.value }); }} />
	                        <Input placeholder="财物负责人" style={{width:'150px'}}
		                        value={this.state.financeLeaderSearch}
		                        onChange={(e) => { this.setState({ financeLeaderSearch: e.target.value }); }} />
	                    </div>
	                </div>
	                <div className="patent-table">
	                    <Spin spinning={this.state.loading}>
	                        <Table columns={this.state.columns}
	                            dataSource={this.state.dataSource}
	                            rowSelection={rowSelection}
	                            pagination={this.state.pagination}
	                            />
	                    </Spin>
	                </div>
	                <MySettlementDetaile
	                	confirmDelet={this.confirmDelet}
	                    userDetaile={this.state.userDetaile}
	                    datauser={this.state.datauser}
	                    showDesc={this.state.showDesc}
	                    closeDesc={this.closeDesc} />
	            </div >
            </div>
        );
    }
}));

export default ProjectOrder;

